# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.datasource import Datasource  # noqa: F401,E501
from swagger_server.models.datasource_type import DatasourceType  # noqa: F401,E501
from swagger_server.models.nwdaf_metrics import NwdafMetrics  # noqa: F401,E501
from swagger_server import util


class NwdafDatasource(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, datasource_type: DatasourceType=None, id: str=None, end_to_end_network_slice_uid: str=None, network_slice_subnet_uid: str=None, flow_id: List[str]=None, api_root: str=None, interval: str=None, metrics: List[NwdafMetrics]=None, topic_name: str=None):  # noqa: E501
        """NwdafDatasource - a model defined in Swagger

        :param datasource_type: The datasource_type of this NwdafDatasource.  # noqa: E501
        :type datasource_type: DatasourceType
        :param id: The id of this NwdafDatasource.  # noqa: E501
        :type id: str
        :param end_to_end_network_slice_uid: The end_to_end_network_slice_uid of this NwdafDatasource.  # noqa: E501
        :type end_to_end_network_slice_uid: str
        :param network_slice_subnet_uid: The network_slice_subnet_uid of this NwdafDatasource.  # noqa: E501
        :type network_slice_subnet_uid: str
        :param flow_id: The flow_id of this NwdafDatasource.  # noqa: E501
        :type flow_id: List[str]
        :param api_root: The api_root of this NwdafDatasource.  # noqa: E501
        :type api_root: str
        :param interval: The interval of this NwdafDatasource.  # noqa: E501
        :type interval: str
        :param metrics: The metrics of this NwdafDatasource.  # noqa: E501
        :type metrics: List[NwdafMetrics]
        :param topic_name: The topic_name of this NwdafDatasource.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'datasource_type': DatasourceType,
            'id': str,
            'end_to_end_network_slice_uid': str,
            'network_slice_subnet_uid': str,
            'flow_id': List[str],
            'api_root': str,
            'interval': str,
            'metrics': List[NwdafMetrics],
            'topic_name': str
        }

        self.attribute_map = {
            'datasource_type': 'datasource-type',
            'id': 'id',
            'end_to_end_network_slice_uid': 'end-to-end-network-slice-uid',
            'network_slice_subnet_uid': 'network-slice-subnet-uid',
            'flow_id': 'flow-id',
            'api_root': 'api-root',
            'interval': 'interval',
            'metrics': 'metrics',
            'topic_name': 'topic-name'
        }
        self._datasource_type = datasource_type
        self._id = id
        self._end_to_end_network_slice_uid = end_to_end_network_slice_uid
        self._network_slice_subnet_uid = network_slice_subnet_uid
        self._flow_id = flow_id
        self._api_root = api_root
        self._interval = interval
        self._metrics = metrics
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'NwdafDatasource':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The nwdaf-datasource of this NwdafDatasource.  # noqa: E501
        :rtype: NwdafDatasource
        """
        return util.deserialize_model(dikt, cls)

    @property
    def datasource_type(self) -> DatasourceType:
        """Gets the datasource_type of this NwdafDatasource.


        :return: The datasource_type of this NwdafDatasource.
        :rtype: DatasourceType
        """
        return self._datasource_type

    @datasource_type.setter
    def datasource_type(self, datasource_type: DatasourceType):
        """Sets the datasource_type of this NwdafDatasource.


        :param datasource_type: The datasource_type of this NwdafDatasource.
        :type datasource_type: DatasourceType
        """

        self._datasource_type = datasource_type

    @property
    def id(self) -> str:
        """Gets the id of this NwdafDatasource.

        Identifier of the NWDAF datasource  # noqa: E501

        :return: The id of this NwdafDatasource.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this NwdafDatasource.

        Identifier of the NWDAF datasource  # noqa: E501

        :param id: The id of this NwdafDatasource.
        :type id: str
        """

        self._id = id

    @property
    def end_to_end_network_slice_uid(self) -> str:
        """Gets the end_to_end_network_slice_uid of this NwdafDatasource.

        The UID of the E2E network slice  # noqa: E501

        :return: The end_to_end_network_slice_uid of this NwdafDatasource.
        :rtype: str
        """
        return self._end_to_end_network_slice_uid

    @end_to_end_network_slice_uid.setter
    def end_to_end_network_slice_uid(self, end_to_end_network_slice_uid: str):
        """Sets the end_to_end_network_slice_uid of this NwdafDatasource.

        The UID of the E2E network slice  # noqa: E501

        :param end_to_end_network_slice_uid: The end_to_end_network_slice_uid of this NwdafDatasource.
        :type end_to_end_network_slice_uid: str
        """

        self._end_to_end_network_slice_uid = end_to_end_network_slice_uid

    @property
    def network_slice_subnet_uid(self) -> str:
        """Gets the network_slice_subnet_uid of this NwdafDatasource.

        The UID of the network slice subnet in the NWDAF domain (mapped in the nsiId in the request). If not specified, anyslice=true 3GPP-compliant  # noqa: E501

        :return: The network_slice_subnet_uid of this NwdafDatasource.
        :rtype: str
        """
        return self._network_slice_subnet_uid

    @network_slice_subnet_uid.setter
    def network_slice_subnet_uid(self, network_slice_subnet_uid: str):
        """Sets the network_slice_subnet_uid of this NwdafDatasource.

        The UID of the network slice subnet in the NWDAF domain (mapped in the nsiId in the request). If not specified, anyslice=true 3GPP-compliant  # noqa: E501

        :param network_slice_subnet_uid: The network_slice_subnet_uid of this NwdafDatasource.
        :type network_slice_subnet_uid: str
        """

        self._network_slice_subnet_uid = network_slice_subnet_uid

    @property
    def flow_id(self) -> List[str]:
        """Gets the flow_id of this NwdafDatasource.

        IDs of the NS flows whose metrics must be retrieved.  # noqa: E501

        :return: The flow_id of this NwdafDatasource.
        :rtype: List[str]
        """
        return self._flow_id

    @flow_id.setter
    def flow_id(self, flow_id: List[str]):
        """Sets the flow_id of this NwdafDatasource.

        IDs of the NS flows whose metrics must be retrieved.  # noqa: E501

        :param flow_id: The flow_id of this NwdafDatasource.
        :type flow_id: List[str]
        """

        self._flow_id = flow_id

    @property
    def api_root(self) -> str:
        """Gets the api_root of this NwdafDatasource.

        Ip address of the api-root to which the HTTP requests must be issued.  # noqa: E501

        :return: The api_root of this NwdafDatasource.
        :rtype: str
        """
        return self._api_root

    @api_root.setter
    def api_root(self, api_root: str):
        """Sets the api_root of this NwdafDatasource.

        Ip address of the api-root to which the HTTP requests must be issued.  # noqa: E501

        :param api_root: The api_root of this NwdafDatasource.
        :type api_root: str
        """

        self._api_root = api_root

    @property
    def interval(self) -> str:
        """Gets the interval of this NwdafDatasource.

        The inter-request interval of the NWDAF datasource.  # noqa: E501

        :return: The interval of this NwdafDatasource.
        :rtype: str
        """
        return self._interval

    @interval.setter
    def interval(self, interval: str):
        """Sets the interval of this NwdafDatasource.

        The inter-request interval of the NWDAF datasource.  # noqa: E501

        :param interval: The interval of this NwdafDatasource.
        :type interval: str
        """

        self._interval = interval

    @property
    def metrics(self) -> List[NwdafMetrics]:
        """Gets the metrics of this NwdafDatasource.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :return: The metrics of this NwdafDatasource.
        :rtype: List[NwdafMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[NwdafMetrics]):
        """Sets the metrics of this NwdafDatasource.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :param metrics: The metrics of this NwdafDatasource.
        :type metrics: List[NwdafMetrics]
        """

        self._metrics = metrics

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this NwdafDatasource.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :return: The topic_name of this NwdafDatasource.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this NwdafDatasource.

        Name of the topic in which the requested metrics retrieved by this datasource will be published. If empty the topic name will follow a common pattern.  # noqa: E501

        :param topic_name: The topic_name of this NwdafDatasource.
        :type topic_name: str
        """

        self._topic_name = topic_name
